import _toConsumableArray from 'babel-runtime/helpers/toConsumableArray';
if (typeof process !== 'undefined' && process.env.NODE_ENV === 'development' && !process.env.DISABLE_ANTD_MOBILE_UPGRADE) {
    try {
        var localVersion = require('./version.json');
        if (!localVersion._disable && fetch) {
            var generateCallbackFunction = function generateCallbackFunction() {
                return 'jsonp_' + Date.now() + '_' + Math.ceil(Math.random() * 100000);
            };

            var clearFunction = function clearFunction(functionName) {
                // IE8 throws an exception when you try to delete a property on window
                // http://stackoverflow.com/a/1824228/751089
                try {
                    delete window[functionName];
                } catch (e) {
                    window[functionName] = undefined;
                }
            };

            var removeScript = function removeScript(scriptId) {
                var script = document.getElementById(scriptId);
                if (script) {
                    document.getElementsByTagName('head')[0].removeChild(script);
                }
            };

            var fetchJsonp = function fetchJsonp(_url) {
                var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

                // to avoid param reassign
                var url = _url;
                var timeout = options.timeout || defaultOptions.timeout;
                var jsonpCallback = options.jsonpCallback || defaultOptions.jsonpCallback;
                var timeoutId = void 0;
                return new Promise(function (resolve, reject) {
                    var callbackFunction = options.jsonpCallbackFunction || generateCallbackFunction();
                    var scriptId = jsonpCallback + '_' + callbackFunction;
                    window[callbackFunction] = function (response) {
                        resolve({
                            ok: true,
                            // keep consistent with fetch API
                            json: function json() {
                                return Promise.resolve(response);
                            }
                        });
                        if (timeoutId) {
                            clearTimeout(timeoutId);
                        }
                        removeScript(scriptId);
                        clearFunction(callbackFunction);
                    };
                    // Check if the user set their own params, and if not add a ? to start a list of params
                    url += url.indexOf('?') === -1 ? '?' : '&';
                    var jsonpScript = document.createElement('script');
                    jsonpScript.setAttribute('src', '' + url + jsonpCallback + '=' + callbackFunction);
                    if (options.charset) {
                        jsonpScript.setAttribute('charset', options.charset);
                    }
                    jsonpScript.id = scriptId;
                    document.getElementsByTagName('head')[0].appendChild(jsonpScript);
                    timeoutId = setTimeout(function () {
                        reject(new Error('JSONP request to ' + _url + ' timed out'));
                        clearFunction(callbackFunction);
                        removeScript(scriptId);
                        window[callbackFunction] = function () {
                            clearFunction(callbackFunction);
                        };
                    }, timeout);
                    // Caught if got 404/500
                    jsonpScript.onerror = function () {
                        reject(new Error('JSONP request to ' + _url + ' failed'));
                        clearFunction(callbackFunction);
                        removeScript(scriptId);
                        if (timeoutId) {
                            clearTimeout(timeoutId);
                        }
                    };
                });
            };
            //#endregion


            //#region fetch-jsonp
            var defaultOptions = {
                timeout: 5000,
                jsonpCallback: 'callback',
                jsonpCallbackFunction: null
            };
            var gateway = 'https://basement-gzone.alipay.com/mgw_proxy/unauthorized_endpoint';
            var params = {
                path: 'antd-mobile-upgrade-tip/upgrade-tip-h5data',
                'x-basement-operation': 'com.alipay.h5data.fengdie.get'
            };
            var requestData = encodeURIComponent(JSON.stringify([params]));
            fetchJsonp(gateway + '?requestData=' + requestData).then(function (res) {
                return res.json();
            }).then(function (data) {
                if (!data.result || !data.result.success) {
                    return;
                } else {
                    data = data.result.result;
                }
                var notice = '';
                var tipComponents = data.filter(function (item) {
                    var key = item.name;
                    if (key === '[notice]') {
                        notice = item.tip;
                    }
                    if (!localVersion[key]) {
                        return false;
                    }
                    var oldVer = localVersion[key].split('.');
                    var newVer = item.version.split('.');
                    var result = false;
                    var length = Math.max(oldVer.length, newVer.length);
                    for (var i = 0; i < length; i++) {
                        if (oldVer[i] !== newVer[i]) {
                            var newVerNum = +newVer[i];
                            var oldVerNum = +oldVer[i];
                            var hasNaN = isNaN(newVerNum) || isNaN(oldVerNum);
                            result = !(!hasNaN && oldVerNum >= newVerNum);
                            if (result) {
                                break;
                            }
                        }
                    }
                    return result;
                });
                if (notice) {
                    console.warn('--------------------------------------------------------\n', '[antd-mobile-upgrade-tip] Notice:\n', notice + '\n', '--------------------------------------------------------');
                }
                if (tipComponents.length > 0) {
                    var _console;

                    (_console = console).warn.apply(_console, ['--------------------------------------------------------\n', '[antd-mobile-upgrade-tip] some components is expired:\n', '\n'].concat(_toConsumableArray(tipComponents.map(function (newData) {
                        var key = newData.name;
                        return key + ': ' + localVersion[key] + ' => ' + newData.version + ' ' + newData.tip + ' ' + newData.url + '\n';
                    })), ['\n', '[you can reinstall node_modules to upgrade all of them.]\n', '[about this] http://mobile.ant.design/docs/react/upgrade-tip-cn\n', '--------------------------------------------------------']));
                }
            })['catch'](function () {});
        }
    } catch (error) {}
}